Bug 11725 - Буфер перекодируется в UNICODE, даже если локаль KOI8-R
: Буфер перекодируется в UNICODE, даже если локаль KOI8-R
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/xterm)
: unstable
: all Linux
: P2 normal
Assigned To:
:
: http://bugs.debian.org/cgi-bin/bugrep...
:
:
:
  Show dependency tree
 
Reported: 2007-05-09 17:14 by
Modified: 2008-07-22 22:27 (History)


Attachments
юникодные танцы нужны только в неоднобайтовых локалях (490 bytes, patch)
2007-05-09 17:23, Fr. Br. George
no flags Details | Diff


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2007-05-09 17:14:59
В 255-alt1.1 появился очередной кусок кода, обрабатывающий UNICODE. Он
обрабатывает этот UNICODE даже если никакого UNICODE нет, если локаль KOI8-R,
например. Всё оттого, что не проверяется, запущен ли xterm в юникоде или без. В
результате русские буквы из буфера при попытке вставить преобразутся в юникод и
отображаются в виде "#######".
Steps to Reproduce:
1. запустить xterm в локали KOI8-R
2. набрать что-нибудь по-русски
3. отметить левой кнопкой
4. вставить средней кнопкой
Actual Results:  
###-###### ##-######


Expected Results:  
что-нибудь по-русски
------- Comment #1 From 2007-05-09 17:23:15 -------
Created an attachment (id=1953) [details]
юникодные танцы нужны только в неоднобайтовых локалях
------- Comment #2 From 2007-05-09 17:25:43 -------
Совсем забыл:

1. Патч прилагается. Влиять на работу при любой двухбайтовой локали не должен.
2. before release
   git-push please
3. Если что-нибудь отметить, foreground-цвета теперь не сохраняются, а
превращаются в background. Это бага или фича?
------- Comment #3 From 2007-05-10 13:24:36 -------
(In reply to comment #1)
> Created an attachment (id=1953) [edit] [details]
> юникодные танцы нужны только в неоднобайтовых локалях
На самом деле нужно вообще выкинуть этот кусок (заменить #if OPT_WIDE_CHARS на
#if 0) - в utf-8 он тоже работает неправильно, поскольку там гвоздями прибит
вызов UTF8toLatin1. Всё это безобразие было затеяно для преобразования некоторых
символов Unicode в близкие по начертанию символы Latin-1, но напрочь сломало
работу в других локалях. Пока что проще просто выкинуть этот кусок.

(In reply to comment #2)
> 2. before release
>    git-push please
+1

> 3. Если что-нибудь отметить, foreground-цвета теперь не сохраняются, а
> превращаются в background. Это бага или фича?
В этой версии добавили ресурс highlightTextColor (хотя вроде бы предполагалось,
что в случае, когда он не задан, сохраняется старое поведение).
------- Comment #4 From 2007-06-10 15:28:00 -------
(In reply to comment #0)
[...]
> Steps to Reproduce:
> 1. запустить xterm в локали KOI8-R
[...]

У меня при локали CP1251 не воспроизводится, хотя по идее должна -- ведь CP1251
тоже однобитная. Интересно, почему?

------- Comment #5 From 2007-06-10 15:28:48 -------
(In reply to comment #4)
> У меня при локали CP1251 не воспроизводится, хотя по идее должна -- ведь CP1251
> тоже однобитная. Интересно, почему?

s/однобитная/однобайтная/

------- Comment #6 From 2007-06-12 13:55:26 -------
(In reply to comment #5)
> (In reply to comment #4)
> > У меня при локали CP1251 не воспроизводится, хотя по идее должна


rpm -qi xterm ?
------- Comment #7 From 2007-06-13 07:17:57 -------
(In reply to comment #6)
> (In reply to comment #5)
> > (In reply to comment #4)
> > > У меня при локали CP1251 не воспроизводится, хотя по идее должна
> rpm -qi xterm ?

[c0der@rock ~]$ rpm -q xterm
xterm-225-alt1.1

------- Comment #8 From 2007-06-20 13:31:08 -------
Я иметь хорошая новость! :)
- Бага действительно имеет место быть, причем похоже, что только в локали KOI8-R
- Бага появилась в версии 225
- Бага исправлена автором в версии 226

На днях я соберу новую версию и могу выложить в Сизиф.

Есть только два маленьких вопроса:
2damir@: давай я себе тогда и  заберу пакет, раз с ним вожусь и de facto являюсь
его мэйнтенером
2all@: какой командой мне смержить сборки xterm'а из git'а Дамира в свой?
------- Comment #9 From 2007-06-20 13:33:51 -------
И вот ещё мысль: можно 226 отправить в Сизиф, а в бранч положить 225 c патчиком
для этой баги. В Дебиане, кстати, патчик чуток другой:
http://bugs.debian.org/cgi-bin/bugreport.cgi?msg=13;att=0;bug=420974

Кто что скажет?
------- Comment #10 From 2007-06-21 17:18:30 -------
В сизиф ушел xterm-225-alt1.2, исправляющий эту багу.

Как только он там появится, прошу проверить, чтоб бага действительно испрвлена
и
тогда его можно будет переложить в бранч. (Ну а потом я уже и 226 в Сизиф
отправлю..)
------- Comment #11 From 2007-07-08 00:55:30 -------
Закрывать будем?
------- Comment #12 From 2007-07-08 06:56:28 -------
Mark as CLOSED.
------- Comment #13 From 2008-07-22 22:27:05 -------
Что-то бага эта у меня снова воспроизвелась на 235-alt1 и локали CP1251 =(